<?php
/*
Plugin Name: HNY JPForms something additional
Plugin URI: http://www.hanano-ya.jp
Description: 素敵な日本産お問い合わせフォームMW WP Form でちょっとした機能を追加する
Author: 花のや
Version: 1.0.1
Author URI: http://www.hanano-ya.jp

Copyright 2014 hananoya (email : info@hanano-ya.jp)

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License, version 2, as
  published by the Free Software Foundation.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

$hny_jsa = new hny_jpforms_something_additional();

class hny_jpforms_something_additional{
  
  private $my_fields = array(
    'hny_jsa_zip',
    'hny_jsa_address',
    'hny_jsa_confirm_scroll',
    'hny_jsa_confirm_button',
    'hny_jsa_confirm_on_button',
    'hny_jsa_send_button',
    'hny_jsa_send_on_button',
    'hny_jsa_back_button',
    'hny_jsa_back_on_button'
  );
  
  public function __construct(){
    add_action('plugins_loaded', array(&$this, 'hny_initialize'));

    register_activation_hook( __FILE__, array(&$this, 'hny_activation'));
    register_uninstall_hook( __FILE__, array(&$this, 'hny_uninstall'));
  }
  public function hny_activation(){
  }
  public function hny_uninstall(){
  }
  /**
  * initialize
  */
  public function hny_initialize(){
    add_action('admin_menu', array(&$this, 'hny_admin_menu'));
    add_action('save_post', array(&$this, 'hny_save_data'));
    
    add_action('wp_print_footer_scripts', array(&$this, 'hny_make_footer_scripts'));
    add_action('wp_print_styles', array(&$this, 'hny_make_styles'));
  }
  /**
  * hook metabox
  */
  public function hny_admin_menu(){
    add_meta_box('jpform_custom', 'JpForm色々', array(&$this,'add_mw_wp_form'), 'mw-wp-form', 'side', 'low');
//    add_meta_box('jpform_custom', 'JpForm色々', array(&$this,'add_mw_wp_form'), 'page', 'side', 'low');
  }

  /**
  * mw wp formでmetaboxとか出力
  */
  public function add_mw_wp_form(){
    wp_enqueue_media();
    wp_enqueue_script( 'custom-header' );
    wp_enqueue_script('hny_uploads',plugin_dir_url(__FILE__).'js/hny_uploads.js',array('jquery'),null,null);
    include_once(plugin_dir_path( __FILE__ ).'template/add_mw_wp_form.php');
  }

  /**
  * update as custom field
  * @bridge
  * @param int.id mw wpform id
  */
  public function hny_save_data($id){
    foreach ($this->my_fields as $fields)
      $this->hny_save_or_update($id, $fields);
  }

  /**
  * update as custm field
  *
  * @param int.id mw wpform id
  * @param string.field_name
  */
  private function hny_save_or_update($id, $fields){
    $my_data = ($_POST[$fields])? esc_html($_POST[$fields]): '';
    update_post_meta($id, $fields, $my_data) ;
  }

  /**
  * get mw wp forms post
  *
  * @return obj.post[mw-wp-form]
  */
  private function hny_get_mw_wp_forms(){
    $args = array(
      'post_type' => 'mw-wp-form',
      'posts_per_page' => -1
    );
    return get_posts($args);
  }

  /**
  * css出力
  */
  public function hny_make_styles(){
    global $post;
    if (function_exists('has_shortcode')){
      if(is_admin() || ! has_shortcode($post->post_content, 'mwform_formkey'))
        return;
    }else{
      if(is_admin())
        return;
    }
    $forms = $this->hny_get_mw_wp_forms();
    $output = '<style type="text/css">'."\n";
    $output .= $this->hny_button2image_style($forms,array('send','confirm','back'),array('input[value="送信する"]','input[name="submitConfirm"]','input[name="submitBack"]'));
    $output .= '</style>'."\n";
    echo $output;
  }

  /**
  * css作成
  *
  * @param array.obj mw_wp_form
  * @param array.string 動作(send,confirm,back)
  * @param array.string selector
  * @return string css
  */
  private function hny_button2image_style($forms,$methods,$selectors){
    $ret = '';
    foreach($forms as $form){
      for($i = 0;$i < count($methods);$i++){
        $standerd = 'hny_jsa_'.$methods[$i].'_button';
        $on = 'hny_jsa_'.$methods[$i].'_on_button';
        if($form->$standerd){
          $img = wp_get_attachment_image_src($form->$standerd,'full');
          $ret .= '#mw_wp_form_mw-wp-form-'.$form->ID.' '.$selectors[$i].'{'.
                  'text-indent:-9999px;border:none;cursor:pointer;'.
                  'background:url('.$img[0].') no-repeat left top;width:'.$img[1].'px;height:'.$img[2].'px;margin:0 5px;'.
                  "}\n";
          if($form->$on){
            $on_img = wp_get_attachment_image_src($form->$on,'full');
            $ret .= '#mw_wp_form_mw-wp-form-'.$form->ID.' '.$selectors[$i].':hover{'.
                    'background:url('.$on_img[0].') no-repeat left top;width:'.$on_img[1].'px;height:'.$on_img[2].'px;'.
                    "}\n";
          }else{
            $ret .= '#mw_wp_form_mw-wp-form-'.$form->ID.' '.$selectors[$i].':hover{'.
                    'opacity:0.75;filter: alpha(opacity=75);-ms-filter: "alpha(opacity=75)";'.
                    "}\n";
          }
        }
      }
    }

    return $ret;
  }

  /**
  * javascript出力
  */
  public function hny_make_footer_scripts(){
    global $post;
    if (function_exists('has_shortcode')){
      if(is_admin() || ! has_shortcode($post->post_content, 'mwform_formkey'))
        return;
    }else{
      if(is_admin())
        return;
    }

    $forms = $this->hny_get_mw_wp_forms();
    $output = '<script src="http://ajaxzip3.googlecode.com/svn/trunk/ajaxzip3/ajaxzip3.js" charset="UTF-8"></script>'."\n";
    $output .= '<script type="text/javascript">'."\n";
    $output .= 'jQuery(document).ready(function($){'."\n";
    $output .= $this->hny_zip2address_script($forms);
    $output .= $this->hny_confirm_scroll_script($forms);
    $output .= '});'."\n";
    $output .= '</script>'."\n";
    echo $output;
  }

  /**
  * javascript作成(ajaxzip3)
  *
  * @param array.obj mw_wp_form
  * @return string css
  */
  private function hny_zip2address_script($forms){
    $ret = '';
    foreach($forms as $form){
      if($form->hny_jsa_zip && $form->hny_jsa_address){
        $ret .= "$('div#mw_wp_form_mw-wp-form-".$form->ID." input[name=\"".$form->hny_jsa_zip."\"]').on('keyup',function(){";
        $ret .= "  AjaxZip3.zip2addr(this,'','".$form->hny_jsa_address."','".$form->hny_jsa_address."');";
        $ret .= "});\n";

        $ret .= "$('div#mw_wp_form_mw-wp-form-".$form->ID." input[name=\"".$form->hny_jsa_zip."\\\\[data\\\\]\\\\[1\\\\]\"]').on('keyup',function(){";
        $ret .= "AjaxZip3.zip2addr('".$form->hny_jsa_zip."[data][0]','".$form->hny_jsa_zip."[data][1]','".$form->hny_jsa_address."','".$form->hny_jsa_address."','".$form->hny_jsa_address."');";
        $ret .= "});\n";
      }
    }
    return $ret;
  }

  /**
  * javascript作成(auto scroll)
  *
  * @param array.obj mw_wp_form
  * @return string css
  */
  private function hny_confirm_scroll_script($forms){
    $ret = '';
    foreach($forms as $form){
      if($form->hny_jsa_confirm_scroll){
        $ret .= "var target".$form->ID." = $('div#mw_wp_form_mw-wp-form-".$form->ID.".mw_wp_form');\n";
        $ret .= "if(target".$form->ID.".length && (target".$form->ID.".hasClass('mw_wp_form_confirm') || target".$form->ID.".find('.error').length)){ $('html, body').animate({scrollTop:target".$form->ID.".offset().top}, 500, 'swing'); }\n";
      }
    }
    return $ret;
  }
  private function hmy_make_mw_wp_filter($forms){
    foreach($forms as $form){
    }
  }
  private function getImageUrlById($id,$size = 'thumbnail'){
    $img = wp_get_attachment_image_src($id,$size);
    return $img[0];
  }

  private function getImageTagById($id,$size = 'thumbnail'){
    return wp_get_attachment_image($id,$size);
  }

}





 
?>